#ifndef _LIBI2CLCD_H
#define _LIBI2CLCD_H

#include <pic18fregs.h>	// /usr/share/sdcc/include/pic16/pic18f*.h

#define I2C_LCD_ADR	0b0111110

#define RS_LOW	0x00
#define RS_HIGH	0x40

#define LCD_MAX_X	8
#define LCD_MAX_Y	2

//					|....,,,8....,,16|.20|,,,....,,,,....,,40|
#define LCD_TITLE1	"PIC LCD "
#define LCD_TITLE2	"Lib 0.99"

void lcd_init();
unsigned char lcd_get_ddadr(char);
void lcd_title();
void lcd_putc(unsigned char);
void lcd_puts(unsigned char*);
void lcd_inc_pos();
void lcd_dec_pos();
void lcd_clear();
void lcd_locate(char, char);
void lcd_cgpat(unsigned char, char pat);
void lcd_out(unsigned char);

#endif /* _LIBI2CLCD_H */

