#include "libusart.h"
#include "libwait.h"

/*------------------------------------------------------------------------------
 *
 *	USART 初期設定
 *
 */
void initUsart() {
									// Baud Rate = FOSC / (16 * (X + 1))
									// 9615.38 = 4,000,000 / (16 * (25 + 1))

//	SPBRGH	= 0;					// Baud Rate Generator(High Byte)
	SPBRG	= BAUDRATE;				// Baud Rate Generator
	BRGH	= 1;					// High Baud Rate Select(High/Low)
//	BRG16	= 0;					// 16-Bit Baud Rate Register Enable bit
	SYNC	= 0;					// USART Mode Select(Synchronous/Asynchronous)

	SPEN	= 1;					// Serial Port Enable
	CREN	= 1;					// Continuous Receive Enable

	TXEN	= 1;					// Transmit Enable
}

/*------------------------------------------------------------------------------
 *
 *	USART 送信処理
 *
 */
void transmitUsart(unsigned char c) {

		while(!TRMT);
		TXREG = c;								// USART Transmit data register
}

/*------------------------------------------------------------------------------
 *
 *	USART 受信処理
 *
 */
unsigned char receiveUsart() {					// データ受信までブロックされる

	unsigned char recv;

	while(1) {
		while(!RCIF);							// 受信フラグチェック

		if(OERR) {								// オーバランエラーチェック
			CREN = 0; CREN = 1;					// 受信回路リセット(OERRクリア)
		}
		if(FERR) {								// フレーミングエラーチェック
			recv = RCREG;						// ゴミを吸い取る
			continue;
		}
		break;
	}
	recv = RCREG;								// エラーなし、受信データを得る 
	return(recv);
}

unsigned char receiveUsartNb() {				// ノンブロック

	unsigned char recv;

	if(!RCIF)									// 受信フラグチェック
		return(0x39);

	while(1) {
		if(OERR) {								// オーバランエラーチェック
			CREN = 0; CREN = 1;					// 受信回路リセット(OERRクリア)
		}
		if(FERR) {								// フレーミングエラーチェック
			recv = RCREG;						// ゴミを吸い取る
			return(0x38);
		}
		break;
	}
	recv = RCREG;								// エラーなし、受信データを得る 
	return(recv);
}

