#ifndef _LIBUSART_H
#define _LIBUSART_H

//#include <pic16f648a.h> // /usr/share/sdcc/non-free/include/pic14/pic16f648a.h, /usr/share/sdcc/include/pic14/pic16f648a.h
#include <pic18fregs.h>	// /usr/share/sdcc/include/pic16/pic18f*.h

//#define BAUDRATE    103				// 4MHz/2400bps
#define BAUDRATE    25					// 4MHz/9600bps
//#define BAUDRATE    12				// 12MHz/57600bps

#define TMR1IF               PIR1bits.TMR1IF                /* bit 0 */
#define TMR2IF               PIR1bits.TMR2IF                /* bit 1 */
#define CCP1IF               PIR1bits.CCP1IF                /* bit 2 */
#define TXIF                 PIR1bits.TXIF                  /* bit 4 */
#define RCIF                 PIR1bits.RCIF                  /* bit 5 */
#define CMIF                 PIR1bits.CMIF                  /* bit 6 */
#define EEIF                 PIR1bits.EEIF                  /* bit 7 */

#define RX9D                 RCSTAbits.RX9D                 /* bit 0 */
#define OERR                 RCSTAbits.OERR                 /* bit 1 */
#define FERR                 RCSTAbits.FERR                 /* bit 2 */
#define ADEN                 RCSTAbits.ADEN                 /* bit 3 */
#define CREN                 RCSTAbits.CREN                 /* bit 4 */
#define SREN                 RCSTAbits.SREN                 /* bit 5 */
#define RX9                  RCSTAbits.RX9                  /* bit 6 */
#define SPEN                 RCSTAbits.SPEN                 /* bit 7 */

#define TX9D                 TXSTAbits.TX9D                 /* bit 0 */
#define TRMT                 TXSTAbits.TRMT                 /* bit 1 */
#define BRGH                 TXSTAbits.BRGH                 /* bit 2 */
#define SYNC                 TXSTAbits.SYNC                 /* bit 4 */
#define TXEN                 TXSTAbits.TXEN                 /* bit 5 */
#define TX9                  TXSTAbits.TX9                  /* bit 6 */
#define CSRC                 TXSTAbits.CSRC                 /* bit 7 */

/*	16F648A	  _______
			-|2	 U	1|-	
			-|3		0|-	
			-|4	 A	7|-	
			-|5		6|-	
	GND		-|		 |-	Vcc
			-|0		7|-	
	RX		-|1		6|-	
	TX		-|2	 B	5|-	
			-|3_____4|-	
*/
/*	18F2420	  _______
			-|E3 U	7|-	
	LED1	-|A0	6|-	
			-|1		5|-	
			-|2		4|-	
			-|3		3|-	
			-|4		2|-	
			-|5		1|-	
	GND		-|	   B0|-	
			-|7		 |-	Vcc
			-|A6	 |-	GND
			-|C0	7|-	RX
			-|1		6|-	TX
			-|2		5|-	
			-|3_____4|-	
*/

void initUsart();
unsigned char receiveUsart();
void transmitUsart(unsigned char c);
void transmitUsartNb(unsigned char c);

#endif /* _LIBUSART_H */

